//
//  DisplayMapViewController.m
//  311Incidents
//
//  Created by Esri Training Services on 5/2/11.
//  Copyright 2011 Esri. All rights reserved.
//

#import "DisplayMapViewController.h"

@implementation DisplayMapViewController

//Step 3c: Create accessor methods for your map view property.
@synthesize mapView = _mapView;

//Step 5c: Create accessor methods for your web map property.
@synthesize webMap = _webMap;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    //Step 3d: Release your map view from memory.
	self.mapView = nil;
    
    //Step 5d: Release your web map from memory.
    self.webMap = nil;
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    
    //Step 6a: Initialize the web map based on the item ID from ArcGIS.com.
    self.webMap = [AGSWebMap webMapWithItemId:@"a78f44f4ca064c49b69dab4d06fa7968" credential:nil];
  
    //Step 7b: Set the web map delegate to the current class.
    self.webMap.delegate = self;
    
    //Step 6b: Open the web map in the map view.
    [self.webMap openIntoMapView:self.mapView];

    
    
    
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - 
#pragma mark Web Map delegate methods


-(void)didOpenWebMap:(AGSWebMap*)webMap intoMapView:(AGSMapView*)mapView{
    
    //Step 8a: Create an instance of a spatial reference object.
    AGSSpatialReference *spatialReference = [AGSSpatialReference spatialReferenceWithWKID:3857];
	
	//Declare the double variables to support your extent.
	double xmin, ymin, xmax, ymax;
	//Assign the initial extent values to your extent variables.
	//These must be transformed to your current spatial reference.
    xmin = -13636188.457;
    ymin = 4545390.753;
    xmax = -13633327.776;
    ymax = 4547968.859;
	
	//Step 8b: Create an instance of an envelope.
	AGSEnvelope *extentEnv = [AGSEnvelope envelopeWithXmin:xmin ymin:ymin xmax:xmax ymax:ymax spatialReference:spatialReference];
    
	//Step 8c: Zoom the map view into the extent envelope.
	[self.mapView zoomToEnvelope:extentEnv animated:YES];
    
}

- (void)webMap:(AGSWebMap *)webMap didFailToLoadWithError:(NSError *)error{
    
    UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Error" message:@"The web map did not load." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
    
    [alertView show];
    [alertView release];
}

@end
